package gui.run;

import java.util.Observable;
import java.awt.*;

public class ObservablePoint extends Observable {

    private Point value = new Point(0,0);

    public synchronized void setValue(Point newValue) {
        if (!newValue.equals(value)) {
            value = newValue;
            super.setChanged();
            super.notifyObservers(this);
        }
    }

    public synchronized Point getValue() {
        return value;
    }
    public String toString(){
        return value.toString();
    }
}
