/**********************************************************
 Copyright (C) 2001 	Daniel Selman

 First distributed with the book "Java 3D Programming"
 by Daniel Selman and published by Manning Publications.
 http://manning.com/selman

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation, version 2.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 The license can be found on the WWW affineTransform:
 http://www.fsf.org/copyleft/gpl.html

 Or by writing to:
 Free Software Foundation, Inc.,
 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 Author can be contacted affineTransform:
 Daniel Selman: daniel@selman.org

 If you make changes you think others would like please
 contact Daniel Selman.
 **************************************************************/

package j3d.examples.keyboardNavigate;

import javax.media.j3d.Node;
import javax.media.j3d.Transform3D;

public class CollisionChecker {
    CollisionDetector collisionDetector = null;

    Transform3D m_ToWorld = null;
    Transform3D m_Transform3D = null;
    Node node = null;
    boolean viewSide = false;

    public CollisionChecker(Node node,
                            CollisionDetector detector,
                            boolean bViewSide) {
        collisionDetector = detector;
        this.node = node;
        viewSide = bViewSide;
    }

    public boolean isCollision(Transform3D t3d) {
        return collisionDetector.isCollision(t3d, viewSide);
    }
}
