// Decompiled by Jad v1.5.8e2. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://kpdus.tripod.com/jad.html
// Decompiler options: packfields(3) packimports(7) deadcode fieldsfirst splitstr(64) nonlb lnc radix(10) lradix(10) 

package j2d.widgets;

import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.Raster;
import java.awt.image.RenderedImage;
import java.awt.image.SampleModel;
import java.awt.image.WritableRaster;
import java.awt.image.renderable.ParameterBlock;
import java.util.HashSet;
import java.util.Iterator;
import javax.media.jai.InterpolationNearest;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;



public class ImageCanvas extends Canvas {
    public static interface PaintListener {

        public abstract void paint(ImageCanvas imagecanvas, Graphics g);
    }


    protected RenderedImage im;
    protected SampleModel sampleModel;
    protected ColorModel colorModel;
    protected int minTileX, maxTileX, minTileY, maxTileY;
    protected int tileWidth, tileHeight, tileGridXOffset, tileGridYOffset;
    protected int imWidth, imHeight, padX, padY;
    protected boolean drawBorder;
    protected int originX, originY, canvasWidth, canvasHeight;
    private Color grayColor, backgroundColor;
    private HashSet paintListeners;

    private synchronized void initialize() {
        int i = im.getMinX();
        int j = im.getMinY();
        if(i < 0 || j < 0) {
            ParameterBlock parameterblock = new ParameterBlock();
            parameterblock.addSource(im);
            parameterblock.add(Math.max(-i, 0));
            parameterblock.add(Math.max(-j, 0));
            parameterblock.add(new InterpolationNearest());
            im = JAI.create("translate", parameterblock, null);
        }
        sampleModel = im.getSampleModel();
        colorModel = im.getColorModel();
        if(colorModel == null) {
            colorModel = PlanarImage.createColorModel(im.getSampleModel());
            if(colorModel == null)
                throw new IllegalArgumentException("ImageCanvas0");
        }
        Object obj = im.getProperty("background_color");
        if(obj != Image.UndefinedProperty)
            backgroundColor = (Color)obj;
        minTileX = im.getMinTileX();
        maxTileX = (im.getMinTileX() + im.getNumXTiles()) - 1;
        minTileY = im.getMinTileY();
        maxTileY = (im.getMinTileY() + im.getNumYTiles()) - 1;
        tileWidth = im.getTileWidth();
        tileHeight = im.getTileHeight();
        tileGridXOffset = im.getTileGridXOffset();
        tileGridYOffset = im.getTileGridYOffset();
        imWidth = im.getMinX() + im.getWidth();
        imHeight = im.getMinY() + im.getHeight();
        originX = originY = 0;
    }

    public ImageCanvas(RenderedImage renderedimage, boolean flag) {
        drawBorder = false;
        canvasWidth = 0;
        canvasHeight = 0;
        grayColor = new Color(192, 192, 192);
        backgroundColor = null;
        paintListeners = new HashSet();
        im = renderedimage;
        drawBorder = flag;
        initialize();
    }

    public ImageCanvas(RenderedImage renderedimage) {
        this(renderedimage, false);
    }

    public void addNotify() {
        super.addNotify();
        initialize();
    }

    public synchronized void set(RenderedImage renderedimage) {
        im = renderedimage;
        initialize();
        repaint();
    }

    public void setOrigin(int i, int j) {
        padX = 0;
        padY = 0;
        originX = i;
        originY = j;
        repaint();
    }

    public int getXOrigin() {
        return originX;
    }

    public int getYOrigin() {
        return originY;
    }

    public int getXPad() {
        return padX;
    }

    public int getYPad() {
        return padY;
    }

    public Dimension getMinimumSize() {
        return new Dimension(im.getMinX() + im.getWidth() + (drawBorder ? 4 : 0), im.getMinY() + im.getHeight() + (drawBorder ? 4 : 0));
    }

    public Dimension getPreferredSize() {
        return getMinimumSize();
    }

    public Dimension getMaximumSize() {
        return getMinimumSize();
    }

    public void setBounds(int i, int j, int k, int l) {
        super.setBounds(i, j, k, l);
        canvasWidth = k;
        canvasHeight = l;
        padX = Math.max((canvasWidth - imWidth - (drawBorder ? 4 : 0)) / 2, 0);
        padY = Math.max((canvasHeight - imHeight - (drawBorder ? 4 : 0)) / 2, 0);
    }

    private int XtoTileX(int i) {
        return (int)Math.floor((double)(i - tileGridXOffset) / (double)tileWidth);
    }

    private int YtoTileY(int i) {
        return (int)Math.floor((double)(i - tileGridYOffset) / (double)tileHeight);
    }

    private int TileXtoX(int i) {
        return i * tileWidth + tileGridXOffset;
    }

    private int TileYtoY(int i) {
        return i * tileHeight + tileGridYOffset;
    }

    public void update(Graphics g) {
        paint(g);
    }

    public synchronized void paint(Graphics g) {
        if(im == null)
            return;
        Graphics2D graphics2d = null;
        if(g instanceof Graphics2D) {
            graphics2d = (Graphics2D)g;
        } else {
            System.err.println(JaiI18N.getString("ImageCanvas1"));
            return;
        }
        Color color = graphics2d.getColor();
        if(drawBorder) {
            g.setColor(new Color(171, 171, 171));
            g.draw3DRect(padX, padY, imWidth + 3, imHeight + 3, true);
            g.draw3DRect(padX + 1, padY + 1, imWidth + 1, imHeight + 1, true);
        }
        Rectangle rectangle = g.getClipBounds();
        if(rectangle == null)
            rectangle = new Rectangle(0, 0, canvasWidth, canvasHeight);
        byte byte0 = ((byte)(drawBorder ? 2 : 0));
        int i = (padX + byte0) - originX;
        int j = (padY + byte0) - originY;
        rectangle.translate(-i, -j);
        int k = XtoTileX(rectangle.x);
        k = Math.max(k, minTileX);
        k = Math.min(k, maxTileX);
        int l = XtoTileX((rectangle.x + rectangle.width) - 1);
        l = Math.max(l, minTileX);
        l = Math.min(l, maxTileX);
        int i1 = YtoTileY(rectangle.y);
        i1 = Math.max(i1, minTileY);
        i1 = Math.min(i1, maxTileY);
        int j1 = YtoTileY((rectangle.y + rectangle.height) - 1);
        j1 = Math.max(j1, minTileY);
        j1 = Math.min(j1, maxTileY);
        if(backgroundColor != null)
            graphics2d.setColor(backgroundColor);
        else
            graphics2d.setColor(grayColor);
        int k1 = im.getMinX();
        int l1 = im.getMinX() + im.getWidth();
        int i2 = im.getMinY();
        int j2 = im.getMinY() + im.getHeight();
        int k2 = rectangle.x + rectangle.width;
        int l2 = rectangle.y + rectangle.height;
        if(k1 > rectangle.x)
            graphics2d.fillRect(rectangle.x + i, rectangle.y + j, k1 - rectangle.x, rectangle.height);
        if(l1 < k2)
            graphics2d.fillRect(l1 + i, rectangle.y + j, k2 - l1, rectangle.height);
        if(i2 > rectangle.y)
            graphics2d.fillRect(k1 + i, rectangle.y + j, l1 - k1, i2 - rectangle.y);
        if(j2 < l2)
            graphics2d.fillRect(k1 + i, j2 + j, l1 - k1, l2 - j2);
        graphics2d.setClip(new Rectangle(i + im.getMinX(), j + im.getMinY(), im.getWidth(), im.getHeight()));
        Point apoint[] = new Point[((l - k) + 1) * ((j1 - i1) + 1)];
        int i3 = 0;
        for(int j3 = i1; j3 <= j1; j3++) {
            for(int k3 = k; k3 <= l; k3++)
                apoint[i3++] = new Point(k3, j3);

        }

        Raster araster[] = PlanarImage.wrapRenderedImage(im).getTiles(apoint);
        int l3 = araster.length;
        for(int i4 = 0; i4 < l3; i4++) {
            Raster raster = araster[i4];
            int j4 = raster.getMinX();
            int k4 = raster.getMinY();
            if(raster == null)
                continue;
            WritableRaster writableraster = (raster instanceof WritableRaster) ? ((WritableRaster)raster).createWritableTranslatedChild(0, 0) : raster.createWritableRaster(sampleModel, raster.getDataBuffer(), new Point(0, 0));
            BufferedImage bufferedimage = new BufferedImage(colorModel, writableraster, colorModel.isAlphaPremultiplied(), null);
            AffineTransform affinetransform = AffineTransform.getTranslateInstance(j4 + i, k4 + j);
            if(backgroundColor != null)
                graphics2d.fillRect(j4 + i, k4 + j, tileWidth, tileHeight);
            graphics2d.drawRenderedImage(bufferedimage, affinetransform);
        }

        graphics2d.setColor(color);
        notifyPaintListeners(graphics2d);
    }

    public void addPaintListener(PaintListener paintlistener) {
        paintListeners.add(paintlistener);
    }

    public void removePaintListener(PaintListener paintlistener) {
        paintListeners.remove(paintlistener);
    }

    private void notifyPaintListeners(Graphics g) {
        for(Iterator iterator = paintListeners.iterator(); iterator.hasNext();
            ((PaintListener)iterator.next()).paint(this, g));
    }
}
